diff --git a/platform/linux-generic/arch/default/odp_sysinfo_parse.c b/platform/linux-generic/arch/default/odp_sysinfo_parse.c
index 53e2aae..cae6d19 100644
--- a/platform/linux-generic/arch/default/odp_sysinfo_parse.c
+++ b/platform/linux-generic/arch/default/odp_sysinfo_parse.c
@@ -5,6 +5,7 @@
  */

 #include <odp_internal.h>
+#include <odp_cpu_internal.h>
 #include <odp_debug_internal.h>
 #include <string.h>

@@ -21,7 +22,7 @@ int cpuinfo_parser(FILE *file ODP_UNUSED, system_info_t *sysinfo)
	return 0;
 }

-uint64_t odp_cpu_hz_current(int id ODP_UNUSED)
+uint64_t _odp_cpu_hz_current(int id ODP_UNUSED)
 {
	return 0;
 }
diff --git a/platform/linux-generic/arch/mips64/odp_sysinfo_parse.c b/platform/linux-generic/arch/mips64/odp_sysinfo_parse.c
index 407264b..d452653 100644
--- a/platform/linux-generic/arch/mips64/odp_sysinfo_parse.c
+++ b/platform/linux-generic/arch/mips64/odp_sysinfo_parse.c
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */

+#include <odp_cpu_internal.h>
 #include <odp_internal.h>
 #include <string.h>

@@ -58,7 +59,7 @@ int cpuinfo_parser(FILE *file, system_info_t *sysinfo)
	return 0;
 }

-uint64_t odp_cpu_hz_current(int id ODP_UNUSED)
+uint64_t _odp_cpu_hz_current(int id ODP_UNUSED)
 {
	return 0;
 }
diff --git a/platform/linux-generic/arch/powerpc/odp_sysinfo_parse.c b/platform/linux-generic/arch/powerpc/odp_sysinfo_parse.c
index 3b88d55..b877059 100644
--- a/platform/linux-generic/arch/powerpc/odp_sysinfo_parse.c
+++ b/platform/linux-generic/arch/powerpc/odp_sysinfo_parse.c
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */

+#include <odp_cpu_internal.h>
 #include <odp_internal.h>
 #include <string.h>

@@ -57,7 +58,7 @@ int cpuinfo_parser(FILE *file, system_info_t *sysinfo)
	return 0;
 }

-uint64_t odp_cpu_hz_current(int id ODP_UNUSED)
+uint64_t _odp_cpu_hz_current(int id ODP_UNUSED)
 {
	return 0;
 }
diff --git a/platform/linux-generic/arch/x86/odp_sysinfo_parse.c b/platform/linux-generic/arch/x86/odp_sysinfo_parse.c
index 96127ec..8e013a9 100644
--- a/platform/linux-generic/arch/x86/odp_sysinfo_parse.c
+++ b/platform/linux-generic/arch/x86/odp_sysinfo_parse.c
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier:     BSD-3-Clause
  */

+#include <odp_cpu_internal.h>
 #include <odp_internal.h>
 #include <string.h>

@@ -38,7 +39,7 @@ int cpuinfo_parser(FILE *file, system_info_t *sysinfo)
	return 0;
 }

-uint64_t odp_cpu_hz_current(int id)
+uint64_t _odp_cpu_hz_current(int id)
 {
	char str[1024];
	FILE *file;
diff --git a/platform/linux-generic/include/odp_cpu_internal.h b/platform/linux-generic/include/odp_cpu_internal.h
index 351d430..8511f86 100644
--- a/platform/linux-generic/include/odp_cpu_internal.h
+++ b/platform/linux-generic/include/odp_cpu_internal.h
@@ -14,6 +14,7 @@ extern "C" {
 #include <odp/api/cpu.h>

 uint64_t _odp_cpu_cycles(void);
+uint64_t _odp_cpu_hz_current(int id);

 #ifdef __cplusplus
 }
diff --git a/platform/linux-generic/include/odp_internal.h b/platform/linux-generic/include/odp_internal.h
index 8bad450..646027a 100644
--- a/platform/linux-generic/include/odp_internal.h
+++ b/platform/linux-generic/include/odp_internal.h
@@ -120,7 +120,6 @@ int _odp_int_name_tbl_init_global(void);
 int _odp_int_name_tbl_term_global(void);

 int cpuinfo_parser(FILE *file, system_info_t *sysinfo);
-uint64_t odp_cpu_hz_current(int id);

 #ifdef __cplusplus
 }
diff --git a/platform/linux-generic/odp_system_info.c b/platform/linux-generic/odp_system_info.c
index bbe5358..ddf1440 100644
--- a/platform/linux-generic/odp_system_info.c
+++ b/platform/linux-generic/odp_system_info.c
@@ -7,6 +7,7 @@
 #include <odp_posix_extensions.h>

 #include <odp/api/system_info.h>
+#include <odp_cpu_internal.h>
 #include <odp_internal.h>
 #include <odp_debug_internal.h>
 #include <odp/api/align.h>
@@ -177,12 +178,12 @@ uint64_t odp_cpu_hz(void)
 {
	int id = sched_getcpu();

-	return odp_cpu_hz_current(id);
+	return _odp_cpu_hz_current(id);
 }

 uint64_t odp_cpu_hz_id(int id)
 {
-	return odp_cpu_hz_current(id);
+	return _odp_cpu_hz_current(id);
 }

 uint64_t odp_cpu_hz_max(void)